#include <cmath>
#include <iostream>
#include <fstream> 
using namespace std;

double dist(double x1, double y1, double x2, double y2){ 
  double res= 0.0;
  res = sqrt(pow((x1-x2),2.0)+pow((y1-y2),2.0));
  return res;
}

int index_ij(int i,int j){ // i numbe rof city, j = 0 gives x, j=1 gives y
  int res;
  res = i * 2 + j;
  return res;
}


void construct( double * villes){

  villes[index_ij(0,0)] = 48.8666; villes[index_ij(0,1)] =  2.3333; // Paris
  villes[index_ij(1,0)] = 43.3000; villes[index_ij(1,1)] =  5.4000; // Marseille
  villes[index_ij(2,0)] = 45.7500; villes[index_ij(2,1)] =  4.4850; // Lyon
  villes[index_ij(3,0)] = 43.6000; villes[index_ij(3,1)] =  1.4333 ; // Toulouse
  villes[index_ij(4,0)] = 43.7000; villes[index_ij(4,1)] =  7.2500; // Nice
  villes[index_ij(5,0)] = 47.2166; villes[index_ij(5,1)] =  -1.5500; // Nantes
  villes[index_ij(6,0)] = 43.6000; villes[index_ij(6,1)] =  3.8833 ; // Montpellier
  villes[index_ij(7,0)] = 48.5833; villes[index_ij(7,1)] =  7.7500; // Strasbourg
  villes[index_ij(8,0)] = 44.8333; villes[index_ij(8,1)] =  -0.5666; // Bordeaux
  villes[index_ij(9,0)] = 50.6333; villes[index_ij(9,1)] =  3.0666 ; // Lille
  villes[index_ij(10,0)] = 48.0833; villes[index_ij(10,1)] =  -1.6833; // Rennes
  villes[index_ij(11,0)] = 49.2500; villes[index_ij(11,1)] =  4.0333; // Reims
  villes[index_ij(12,0)] = 45.4333; villes[index_ij(12,1)] =  4.4000 ; // Saint Etienne
  villes[index_ij(13,0)] = 49.5000; villes[index_ij(13,1)] =  0.1333; // Le Havre
  villes[index_ij(14,0)] = 43.1166; villes[index_ij(14,1)] =  5.9333; // Toulon
  villes[index_ij(15,0)] = 45.1666; villes[index_ij(15,1)] =  5.7166 ; // Grenoble
  villes[index_ij(16,0)] = 47.3166; villes[index_ij(16,1)] =  5.0166; // Dijon
  villes[index_ij(17,0)] = 47.4666; villes[index_ij(17,1)] =  -0.5500; // Angers
  villes[index_ij(18,0)] = 43.8333; villes[index_ij(18,1)] =  4.3500; // Nimes
  villes[index_ij(19,0)] = 45.7666; villes[index_ij(19,1)] =  4.8833; // VilleurBannes
  villes[index_ij(20,0)] = 43.5333; villes[index_ij(20,1)] =  5.4333; // Aix-en-provence
  villes[index_ij(21,0)] = 48.0060; villes[index_ij(21,1)] =  0.1995; // Le Mans
  villes[index_ij(22,0)] = 45.7833; villes[index_ij(22,1)] =  3.0833; // Clermont Ferrand
  villes[index_ij(23,0)] = 48.4000; villes[index_ij(23,1)] =  -4.4833; // Brest
  villes[index_ij(24,0)] = 47.3833; villes[index_ij(24,1)] =  0.6833; // Tours
  villes[index_ij(25,0)] = 49.9000; villes[index_ij(25,1)] =  2.3000; // Amiens
  villes[index_ij(26,0)] = 45.8500; villes[index_ij(26,1)] =  1.2500; // Limoges
  villes[index_ij(27,0)] = 45.9000; villes[index_ij(27,1)] =  6.1166; // Annecy
  villes[index_ij(28,0)] = 42.6833; villes[index_ij(28,1)] =  2.8833; // Perpignan
  villes[index_ij(29,0)] = 48.8333; villes[index_ij(29,1)] =  2.2500; // Boulogne
  villes[index_ij(30,0)] = 49.1333; villes[index_ij(30,1)] =  6.1666; // Metz
  villes[index_ij(31,0)] = 47.2500; villes[index_ij(31,1)] =  6.0333; // Besancon
  villes[index_ij(32,0)] = 47.9166; villes[index_ij(32,1)] =  1.9000; // Orleans
  villes[index_ij(33,0)] = 48.9333; villes[index_ij(33,1)] =  2.3583; // Saint Senis
  villes[index_ij(34,0)] = 48.9500; villes[index_ij(34,1)] =  2.2500; // Argenteuil
  villes[index_ij(35,0)] = 49.4333; villes[index_ij(35,1)] =  1.0833; // Rouen
  villes[index_ij(36,0)] = 47.7500; villes[index_ij(36,1)] =  7.3333; // Mulhouse
  villes[index_ij(37,0)] = 48.7666; villes[index_ij(37,1)] =  1.3666; // Montreuil
  villes[index_ij(38,0)] = 49.1833; villes[index_ij(38,1)] =  -0.3500; // Caen
  villes[index_ij(39,0)] = 48.6833; villes[index_ij(39,1)] =  6.2000; // Nancy
  villes[index_ij(40,0)] = 50.7166; villes[index_ij(40,1)] =  3.1500; // Tourcoing
  villes[index_ij(41,0)] = 50.7000; villes[index_ij(41,1)] =  3.1666; // Roubaix
  villes[index_ij(42,0)] = 48.9000; villes[index_ij(42,1)] =  2.2000; // Nanterre
  villes[index_ij(43,0)] = 48.7833; villes[index_ij(43,1)] =  2.4000; // Vitry
  villes[index_ij(44,0)] = 43.9500; villes[index_ij(44,1)] =  4.8166; // Avignon
  villes[index_ij(45,0)] = 48.7833; villes[index_ij(45,1)] =  2.4666; // Creteil
  villes[index_ij(46,0)] = 51.0500; villes[index_ij(46,1)] =  2.3666; // Dunkerque
  villes[index_ij(47,0)] = 46.5833; villes[index_ij(47,1)] =  0.3333; // Poitiers
  villes[index_ij(48,0)] = 48.9166; villes[index_ij(48,1)] =  2.2833; // Aubervilliers
  villes[index_ij(49,0)] = 48.9140; villes[index_ij(49,1)] =  2.2853; // Asnieres

}

  
int main() {
  double* villes = new double[100];           // tableau des lattitudes et longitudes pour chaque ville
  int k=0;
  int nb_part =12;                            // nombre de groupe que l'ont souhaite
  double *centres = new double[2*nb_part];    // tableau lattitudes et longitudes pour chaque ville qui sont un centre de groupe
  int cv=0;
  double minimum=1000, res=1000;             
  int* villes_vers_part = new int[50];       // tableau donnant le groupe auquel appartient chaque ville
  double xj=0.0,yj=0.0,cix=0.0,ciy=0.0;
  double erreur=0.0, erreurp=0.0;
  int count=0,iter=0;
  construct(villes);

  // init ; On initialise les centres de groupe avec les 12 premières villes
  for(int i =0; i < nb_part;i++){
    centres[index_ij(i,0)]= villes[index_ij(i,0)];
    centres[index_ij(i,1)]= villes[index_ij(i,1)];
  }

  iter=0;
  erreurp=1.0;
  while( cv ==0){    // test convergence algorithme
   
    // construction partition
    for(int j =0; j < 50;j++){    // indice de ville
      xj=villes[index_ij(j,0)];
      yj=villes[index_ij(j,1)];
      minimum=dist(xj,yj,centres[index_ij(0,0)],centres[index_ij(0,1)]);   // distance entre la ville et le premier centre de la liste
      for(int i =1; i < nb_part;i++){   // indice de groupe
        res=dist(xj,yj,centres[index_ij(i,0)],centres[index_ij(i,1)]);  // distance entre la ville et le centre suivant
        if(res < minimum){
          minimum = res;
          villes_vers_part[j]=i; // la ville j appartient au groupe i car la distance au centre du groupe i est la plus petite jusqu'a maintenant
        }
      }
    }

    // calcul nouveaux centres
    for(int i =0; i < nb_part;i++){
      count = 0;
      centres[index_ij(i,0)]= 0.0;
      centres[index_ij(i,1)]= 0.0;  
      for(int j =0; j < 50;j++){
        if(villes_vers_part[j]==i){
          centres[index_ij(i,0)]+= villes[index_ij(j,0)];
          centres[index_ij(i,1)]+= villes[index_ij(j,1)]; 
          count = count +1;
        }
      }
      centres[index_ij(i,0)]/=count;
      centres[index_ij(i,1)]/=count;
    } 

    // erreur on calcul la distance entre les centres et les villes et on fait une moyenne
    erreur =0.0;
    for(int i =0; i < nb_part;i++){
      cix = centres[index_ij(i,0)];
      ciy = centres[index_ij(i,1)];
      for(int j =0; j < 50;j++){
        if(villes_vers_part[j]==i){
          xj=villes[index_ij(j,0)];
          yj=villes[index_ij(j,1)];
          erreur+=pow(dist(xj,yj,cix,ciy),2.0); 
        }
      }
      erreur = erreur/nb_part;
    } 
    cout<<" iter >>>"<<iter<<" "<<erreur<<" "<<endl;
    iter = iter +1;
    if (abs(erreur-erreurp) < 0.0001 | iter >10){
      cv =1;
    }
    erreurp=erreur;
  }

  for(int i =0; i < nb_part;i++){
    cout<< "region >>"<<i<<endl;
    for(int j =0; j < 50;j++){
        if(villes_vers_part[j]==i){
        cout<< "ville >>"<<j<<endl;
        }
      }
    cout<<"///////////"<<endl;  
  }
  return 0;
}

